package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZSample0003;
import cn.ibizlab.core.sample.filter.IBIZSample0003SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface IBIZSample0003Mapper extends BaseMapper<IBIZSample0003> {

    Page<IBIZSample0003> searchCurData(IPage page, @Param("srf") IBIZSample0003SearchContext context, @Param("ew") Wrapper<IBIZSample0003> wrapper);
    Page<IBIZSample0003> searchDefault(IPage page, @Param("srf") IBIZSample0003SearchContext context, @Param("ew") Wrapper<IBIZSample0003> wrapper);
    Page<IBIZSample0003> searchTopData(IPage page, @Param("srf") IBIZSample0003SearchContext context, @Param("ew") Wrapper<IBIZSample0003> wrapper);
    @Override
    IBIZSample0003 selectById(Serializable id);
    @Override
    int insert(IBIZSample0003 entity);
    @Override
    int updateById(@Param(Constants.ENTITY) IBIZSample0003 entity);
    @Override
    int update(@Param(Constants.ENTITY) IBIZSample0003 entity, @Param("ew") Wrapper<IBIZSample0003> updateWrapper);
    @Override
    int deleteById(Serializable id);
    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZSample0003> selectByPibizsample0003id(@Param("ibizsample0003id") Serializable ibizsample0003id);

}
